C      PROGRAM  BENCHMARK
C
C
C
C     WE KINDLY ASK TO EVALUATE COMPUTING MACHINERY EFFICIENCY
C     NAMELY  MACHINE TIME TOTAL CONSUMPTION AND CPU TIME UNDER
C     SOLVING A CHECK PROBLEM.
C     THE CHECK PROBLEM REPRESENTS THE FOLLOWING PROCEDURES:
C     ALGEBRAIC EQUATIONS SYSTEM SOLUTION (AX=B) USING OVER
C     RELAXATION METHOD (LSOR) AND MATRIX PER ARRAY MULTIPLI-
C     CATION (R=AX) (MULTS).
C     THE PROGRAM CONSISTS OF:
C  1.PROGRAM  CALL (FACTORS PROCESSING OF FIVE-DIAGONAL
C    SYMMETRIC MATRIX A, LSOR , MULTS SUBROUTINES CALL ,QUADRA-
C    TIC ERROR CALCULATION,RESULTS LISTING),
C  2.LSOR SUBROUTINES
C  3.MVLTS SUBROUTINES
C
C    LISTING OF SOLUTION RESULTS HAS THE FOLLOWING INTERPRETA-
C    TION (VIEW):
C
C  PRECISION  0.0000000   ALFA     1.70000
C
C  ITERATIONS       0000
C
C  ERROR   0.000000000000000000E-000
C
C  SOLUTION - CONTROL POINTS
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C
C
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C  00.00   00.00   .....   00.00
C
C USERS SHOULD ONLY TAKE CARE OF MACHINE TIME CONSUMPTION
C LISTING OF TNE GIVEN PROBLEM SOLUTION.
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
      PARAMETER (MM=50,LL=50)
C     IMPLICIT REAL*8 (D)
      REAL *8 DTI
      DOUBLE PRECISION DD,DX,DB,DU1,DU2,DR,DE,DA
      COMMON /DIAG/DD(MM,LL) /PRESS/DX(MM,LL) /FREEN/DB(MM,LL)
      COMMON /GVGH/DU1(MM,LL),DU2(MM,LL) /CONST/N,M,L
     * /ALFA1/E,ALFA,KK /ER/ DR(MM,LL)
      PRINT *,' TEST BEGIN...'
      PMAX=30.
      E=0.00001
      M=MM
      L=LL
      N=M*L
      ALFA=1.7
      DO 1 J=1,L
        DO 1 I=1,M
          K=(J-1)*M+I
          DD(I,J)=-2.0
          DX(I,J)=0.0
          DB(I,J)=0.0
          DU1(I,J)=1.0
          DU2(I,J)=1.0
          IF(I.EQ.M) DU1(I,J)=0.0
          IF(J.EQ.L) DU2(I,J)=0.0
          IF(I.NE.1) DD(I,J)=DD(I,J)-DU1(I,J)
          IF(J.NE.1) DD(I,J)=DD(I,J)-DU2(I,J)
    1 CONTINUE
      A=2.
      DB(1,1)=DB(1,1)-A*30.0
      DD(1,1)=DD(1,1)-A
      DB(M,1)=DB(M,1)-A*10.0
      DD(M,1)=DD(M,1)-A
      DB(1,L)=DB(1,L)-A*10.0
      DD(1,L)=DD(1,L)-A
      DB(M,L)=DB(M,L)-A*10.0
      DD(M,L)=DD(M,L)-A
      CALL STIMER(DTI)
      CALL LSORG
      CALL FTIMER(DTI)
      CALL MULTS
      DE=0.0
      DO 2 J=1,L
        DO 2 I=1,M
          DA=DB(I,J)-DR(I,J)
   2      DE=DE+DA*DA
      OPEN (8,FILE='TEST.REZ')
      WRITE(8,'(12H PRECISION  ,F10.7,7H  ALFA ,F10.5)')E,ALFA
      WRITE(8,*) 'ITERATIONS',KK
      WRITE(8,*)'ERROR   ',DE
      WRITE(8,*)' SOLUTION - CONTROL POINTS'
      WRITE(8,'(10F8.2)')(DX(I,I),I=1,M)
      WRITE(8,'(/)')
      WRITE(8,'(10F8.2)')(DX(I,M+1-I),I=1,M)
      CALL PTIMER(8)
      CLOSE (8)
      WRITE(6,'(12H PRECISION  ,F10.7,7H  ALFA ,F10.5)')E,ALFA
      WRITE(6,*) 'ITERATIONS',KK
      WRITE(6,*)'ERROR   ',DE
      WRITE(6,*)' SOLUTION - CONTROL POINTS'
      WRITE(6,'(10F8.2)')(DX(I,I),I=1,M)
      WRITE(6,'(/)')
      WRITE(6,'(10F8.2)')(DX(I,M+1-I),I=1,M)
      CALL PTIMER(6)
      STOP
      END
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
       SUBROUTINE MULTS
C                           R=A*X
C      +                                   +   + +   + +
C      |D  U1       U2         .           |   |X|   |R|
C      |U1 D  U1       U2      .           |   |X|   |R|
C      |   U1 D  U1       U2   .           |   |X|   |R|
C      |      U1 D           U2.           |   |X|   |R|
C      |U2          D  U1      .U2         |   |X|   |R|
C      |   U2       U1 D  U1   .   U2      |   |X|   |R|
C      |      U2       U1 D  U1.      U2   | * |X| = |R|
C      |.  .  .  U2 .  .  U1 D .   .  .  U2|   |X|   |R|
C      |            U2         .D  U1      |   |X|   |R|
C      |               U2      .U1 D  U1   |   |X|   |R|
C      |                  U2   .   U1 D  U1|   |X|   |R|
C      |                     U2.      U1 D |   |X|   |R|
C      +                                   +   + +   + +
C
C
       DOUBLE PRECISION D,U1,U2,B,TD,UM,Z,X,R
       PARAMETER (NN=50*50)
       COMMON /DIAG/D(NN)  /FREEN/B(NN)
       COMMON /GVGH/U1(NN),U2(NN)
       COMMON /PRESS/X(NN)
       COMMON /CONST/L,N,M
       COMMON /ER/R(NN)
       L1=L-N+1
       R(1)=D(1)*X(1)+U1(1)*X(2)
       I=1
       K1=N-1
   47  I=I+1
       IF(I-N) 44,45,46
   44  J=I-1
       R(I)=U1(J)*X(J)+D(I)*X(I)+U1(I)*X(I+1)
       GO TO 47
   45  R(N)=U1(K1)*X(K1)+D(N)*X(N)
   46  IF(M-1) 48,48,49
   49  DO 50 I=1,N
   50  R(I)=R(I)+U2(I)*X(I+N)
       K=N+1
   55  IF(K-L1) 51,52,48
   51  K1=K-N
       R(K)=U2(K1)*X(K1)+D(K)*X(K)+U1(K)*X(K+1)+U2(K)*X(K+N)
       I=K
       K1=K+N-1
   56  I=I+1
       J=I-1
       J1=I-N
       IF(I-K1) 53,54,48
   53  R(I)=U2(J1)*X(J1)+U1(J)*X(J)+D(I)*X(I)+U1(I)*X(I+1)+U2(I)*X(I+N)
       GO TO 56
   54  R(K1)=U2(J1)*X(J1)+U1(J)*X(J)+D(K1)*X(K1)+U2(K1)*X(K1+N)
       K=K+N
       GO TO 55
   52  K1=K-N
       R(K)=U2(K1)*X(K1)+D(K)*X(K)+U1(K)*X(K+1)
       I=K
   59   I=I+1
       J=I-1
       J1=I-N
       IF(I-L) 57,58,48
   57  R(I)=U2(J1)*X(J1)+U1(J)*X(J)+D(I)*X(I)+U1(I)*X(I+1)
       GO TO 59
   58  R(L)=U2(J1)*X(J1)+U1(J)*X(J)+D(L)*X(L)
   48  CONTINUE
       RETURN
       END
C
C
C
C
      SUBROUTINE LSORG
      PARAMETER(NN=50*50,MM=50)
      DOUBLE PRECISION R,GV,GH,D,B,P,S,G,Q,AG
      DOUBLE PRECISION ALP
      COMMON /CONST/N,M,L
      COMMON /ALFA1/E,ALFA,KK
      COMMON  /GVGH/GH(NN),GV(NN) /DIAG/D(NN)
      COMMON /PRESS/ P(NN) /FREEN/B(NN)
      DIMENSION S(MM),R(MM),G(MM),Q(NN)
      KK=0
   21 CONTINUE
      MA=0
      KK=KK+1
C     IF(KK.GT.182) RETURN
      DO 1 J=1,L
        M1=(J-1)*M
        M1B=M1+1
        M2=M1+M+1
        DO 6 I=1,M
          K=M1+I
    6     R(I)=B(K)
        IF(J.EQ.1) GO TO 12
        DO 7 I=1,M
          K=M1+I-M
    7     R(I)=R(I)-GV(K)*P(K)
   12   IF(J.EQ.L) GO TO 13
        DO 8 I=1,M
          K=M1+I
    8     R(I)=R(I)-GV(K)*P(K+M)
   13   CONTINUE
        IF(D(M1B)) 3,4,3
    4   Q(1)=0.
        G(1)=0.
        GO TO 5
    3   G(1)=R(1)/D(M1B)
        Q(1)=GH(M1B)/D(M1B)
    5   DO 2 I=2,M
          K=M1+I
          S(I)=D(K)-GH(K-1)*Q(I-1)
          IF(S(I)) 10,11,10
   11     Q(I)=0.
          G(I)=0.
          GO TO 2
   10     Q(I)=GH(K)/S(I)
          G(I)=(R(I)-GH(K-1)*G(I-1))/S(I)
    2     CONTINUE
        DO 9 I=2,M
          K=M+1-I
    9     G(K)=G(K)-Q(K)*G(K+1)
        DO 14 I=1,M
          K=M1+I
          ALP=ALFA*(P(K)-G(I))
          G(I)=P(K)-ALP
          AG=G(I)-P(K)
          IF(AG.LT.0.) AG=-AG
          IF(AG.GT.E) MA=1
   14     P(K)=G(I)
    1   CONTINUE
      IF(MA.NE.0) GO TO 21
      RETURN
      END
